Main Page | Class Hierarchy | Alphabetical List | Compound List | Compound Members

# IRdWidgetVisualization Struct Reference

Inherits IRsObject.

List of all members.

## Public Member Functions
HRESULT | GetMesh ([in] GUID *pWidgetState,[out]IRdMesh **ppMesh)
HRESULT | GetMaterial ([in] GUID *pWidgetState,[out, retval]IRsDataObject **ppMaterial)
HRESULT | GetTransform ([in] GUID *pWidgetState,[out, retval]IRdMatrixf **ppTransform)
HRESULT | GetTransformNode ([in] GUID *pWidgetState,[out, retval]IRsBaseNode **ppTransformNode)
HRESULT | SetWidgetVisualization ([in] IRsUnknownWidgetVisualizationCtrl *pWidgetVis)
HRESULT | GetRenderAttributes ([in] GUID *pWidgetState,[out, retval]IRsDataObject **ppRenderAttributes)
HRESULT | SetShapeRayDistance ([in] RtFloat fDistance)
HRESULT | GetResourcesTimestamp ([in] GUID *pWidgetState,[out] RtUlong *puMeshTimestamp,[out] RtUlong *puMaterialTimestamp,[out] RtUlong *puRenderAttribsTimestamp)

## Detailed Description

Widget visualisation position data object is used to specify visual representation of the widget. But because these resources need to be accessible during rendering of widgets (not just read threads), its evaluation of must be done out of kernel. Callback mechanism is used to perform the task.

## Member Function Documentation

HRESULT IRdWidgetVisualization::GetMesh | ( | [in] GUID * | pWidgetState,
|  | [out] IRdMesh ** | ppMesh
| ) |

  | Return mesh according to widget state. Evaluation is not cached. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  ppMesh | Returned mesh for selected state.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::GetMaterial | ( | [in] GUID * | pWidgetState,
|  | [out, retval] IRsDataObject ** | ppMaterial
| ) |

  | Return material according to widget state. Evaluation is not cached. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  ppMaterial | Returned material for selected state.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::GetTransform | ( | [in] GUID * | pWidgetState,
|  | [out, retval] IRdMatrixf ** | ppTransform
| ) |

  | Return transform matrix according to widget state. Evaluation is not cached. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  ppTransform | Returned transform matrix for selected state.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::GetTransformNode | ( | [in] GUID * | pWidgetState,
|  | [out, retval] IRsBaseNode ** | ppTransformNode
| ) |

  | Return transform node according to widget state. Evaluation is not cached. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  ppTransformNode | Returned transform node for selected state.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::SetWidgetVisualization | ( | [in] IRsUnknownWidgetVisualizationCtrl * | pWidgetVis | ) |

  | Set widget visualizaton node. Parameters:
  pWidgetVis | Widget visualization object to set
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::GetRenderAttributes | ( | [in] GUID * | pWidgetState,
|  | [out, retval] IRsDataObject ** | ppRenderAttributes
| ) |

  | Return render attributes according to widget state. Evaluation is not cached. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  ppRenderAttributes | Returned render attributes data object for selected state.
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::SetShapeRayDistance | ( | [in] RtFloat | fDistance | ) |

  | Call to set shape ray distance. Set must be called from master thread. Parameters:
  fDistance | Distance to set to visualization node
Returns: standard HRESULT processing can be applied to returned value

HRESULT IRdWidgetVisualization::GetResourcesTimestamp | ( | [in] GUID * | pWidgetState,
|  | [out] RtUlong * | puMeshTimestamp,
|  | [out] RtUlong * | puMaterialTimestamp,
|  | [out] RtUlong * | puRenderAttribsTimestamp
| ) |

  | Return resources timestamps according to widget state. Timestamps start at 0 and are incremented each time when they are changed. This method can be called from any thread, but caller must take care that object is not destroyed before return. Parameters:
  pWidgetState | Specifies widget state
  puMeshTimestamp | Mesh timestamp
  puMaterialTimestamp | Material timestamp
  puRenderAttribsTimestamp | Render attributes timestamp
Returns: standard HRESULT processing can be applied to returned value